#ifndef SW_PARSE_TREE_H
#define SW_PARSE_TREE_H


#include "Constants.h"
#include "its.h"


class ParseTree {
public:
    ParseTree() {
    }

    void randomize() {
        RandTree(_tree, initialDeciderSize);
    }

    static void crossover(ParseTree& one, ParseTree& two) {
        Cross(one._tree, two._tree, maxDeciderSize);
    }

    int evaluate(int* args) const {
        return EvalTreeV(_tree, args);
    }

private:
    int _tree[maxDeciderSize + 1];
};


inline void crossover(ParseTree& one, ParseTree& two) {
    ParseTree::crossover(one, two);
}


#endif
