/* See implementation file Random378.cpp */
/* for credits and documentation         */

#ifndef RANDOM_378_H
#define RANDOM_378_H

//seed for random number generator
void seedMT(long seed);

//random integer
unsigned long lrandMT();

//random double
double drandMT();

inline float frandMT() {
    return static_cast<float>(drandMT());
}


// Returns random integer in the range [low, high), low != high
inline unsigned long random(unsigned long low, unsigned long high) {
    return lrandMT() % (high - low) + low;
}

inline unsigned long randMT(unsigned long range) {
    return lrandMT() % range;
}

inline bool randomBit() {
    return lrandMT() % 2 == 1;
}

#endif
